﻿using UnityEngine;
using System.Collections;

public class AbilitiesManager : MonoBehaviour {

	public static AbilitiesManager Instance {
		get {
			return instance;
		}
	}

	public bool CanJump {
		get {
			return canJump;
		}
	}

	public bool CanMoveLeft {
		get {
			return canMoveLeft;
		}
	}

	public bool CanMoveRight {
		get {
			return canMoveRight;
		}
	}

	public bool InAllAbilitiesField {
		set {
			inAllAbilitiesField = value;

			if (inAllAbilitiesField) {
				canJump = true;
				canMoveLeft = true;
				canMoveRight = true;
			}
		}
	}

	private bool canJump = true;
	private bool canMoveLeft = true;
	private bool canMoveRight = true;
	private bool inAllAbilitiesField = false;

	private static AbilitiesManager instance;
	
	void Awake() {
		instance = this;
	}

	public void AllowJump() {
		canJump = true;
	}

	public void AllowMoveLeft() {
		canMoveLeft = true;
	}

	public void AllowMoveRight() {
		canMoveRight = true;
	}

	public void ForbidJump() {
		if (inAllAbilitiesField == false) {
			canJump = false;
		}
	}
	
	public void ForbidMoveLeft() {
		if (inAllAbilitiesField == false) {
			canMoveLeft = false;
		}
	}
	
	public void ForbidMoveRight() {
		if (inAllAbilitiesField == false) {
			canMoveRight = false;
		}
	}
}
