﻿using UnityEngine;
using System.Collections;

[RequireComponent (typeof(SpriteRenderer))]
public class AbilityPickup : MonoBehaviour {

	public enum Type {
		MoveLeft,
		MoveRight,
		Jump
	}

	public Type type;

	private bool pickedUp = false;
	private SpriteRenderer thisSpriteRenderer;

	void Awake() {
		thisSpriteRenderer = GetComponent<SpriteRenderer>();
	}

	void OnTriggerEnter2D(Collider2D other) {
		
		if (!pickedUp && other.tag == "Player") {

			switch (type) {
			case Type.Jump:
				AbilitiesManager.Instance.AllowJump();
				break;
			case Type.MoveLeft:
				AbilitiesManager.Instance.AllowMoveLeft();
				break;
			case Type.MoveRight:
				AbilitiesManager.Instance.AllowMoveRight();
				break;
			}
			pickedUp = true;
			StartCoroutine(DieCoroutine());
		}
	}

	IEnumerator DieCoroutine() {

		Vector3 startScale = transform.localScale;
		float elapsedTime = 0.0f;

		while(thisSpriteRenderer.color.a > 0.01f) {
			thisSpriteRenderer.color = Color.Lerp(thisSpriteRenderer.color, new Color(1.0f, 1.0f, 1.0f, 0.0f), Time.deltaTime * 10.0f);
			transform.localScale = startScale * (1.0f + elapsedTime * 2.0f);
			elapsedTime += Time.deltaTime;
			yield return 0;
		}

		DestroyObject(this.gameObject);
	}
}
