using UnityEngine;
using System.Collections;

public class CheckPointManager {

	public static CheckPointManager Instance {
		get {
			if (instance == null) {
				instance = new CheckPointManager();
			}
			return instance;
		}
	}
	
	public int MaxCheckPointReached {
		get {
			return maxCheckPointReached;
		}
	}
	
	
	private static CheckPointManager instance; 
	private int maxCheckPointReached;
	private int lastLevelNum;
	
	public void Reset() {

		maxCheckPointReached = 0;
	}
	
	public void CheckPointReached(int levelNum, int checkPointNumber) {

		if (levelNum != lastLevelNum) {
			Reset();
			lastLevelNum = levelNum;
		}
		
		if (checkPointNumber > maxCheckPointReached) {
			maxCheckPointReached = checkPointNumber;
		}
	}
}
