﻿using UnityEngine;
using System.Collections;

public class FlexyFollow: MonoBehaviour {

	public GameObject followObject;
	public float followSpeed = 2.0f;
	public Vector3 offset;
	
	private Transform followTransform;
	private Transform thisTransform;
	
	void Start () {

		thisTransform = this.transform;
		followTransform = followObject.transform;
		thisTransform.position = followTransform.position + offset;	
	}
	
	void Update () {

		Vector2 gravity = Physics2D.gravity;
		Vector3 upVector = new Vector3(-gravity.x, -gravity.y, 0.0f);

		Quaternion rot = new Quaternion();
		rot.SetLookRotation(new Vector3(0.0f, 0.0f, 1.0f), upVector);
		Vector3 v = rot * offset;

		Vector3 destPos = followTransform.position + v;
		Vector3 newPos = Vector3.Lerp(thisTransform.position, destPos, Time.deltaTime * followSpeed);
		thisTransform.position = newPos;		
	}
}
