﻿using UnityEngine;
using System.Collections;

public class FloorCheck : MonoBehaviour {

	public float offset = 1.0f;

	[HideInInspector]
	public Transform floorTransform; // read only

	private Transform thisTransform;
	private Transform parentTransform;
	
	void Start () {

		thisTransform = transform;
		parentTransform = thisTransform.parent;
	}

	void FixedUpdate () {
	
		Vector2 gravityNormalized = Physics2D.gravity.normalized;
		Vector3 offsetVector = new Vector3(gravityNormalized.x * offset, gravityNormalized.y * offset, 0.0f);
		thisTransform.position = parentTransform.position + offsetVector;
	}

	void OnTriggerEnter2D(Collider2D other) {

		if (other.transform != floorTransform && other.tag == "Ground") {
			floorTransform = other.transform;
		}

	}

	void OnTriggerExit2D(Collider2D other) {
		floorTransform = null;
	}
}